mysite/enquetes/urls.py
from django.urls import path

from . import views

app_name = 'enquetes'
urlpatterns = [
    # ex.: /
    path('', views.index, name='index'),
    # ex.: detalhes - /enquete/5/
    path('enquete/<int:id_pergunta>/votacao', views.detalhes, name='detalhes'),
     # ex.: votação- /enquete/5/votacao
    path('enquete/<int:id_pergunta>/votacao/', views.votacao, name='votacao'),
     # ex.: resultado - /enquete/5/ resultado
    path('enquete/<int:id_pergunta>/resultado/', views.resultado, name='resultado'),

    ]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('enquetes.urls')),
]

mysite/enquetes/models.py
from django.db import models
import datetime
from django.utils import timezone
# Create your models here.

class Pergunta(models.Model):
    texto = models.CharField(max_length = 200)
    data_pub = models.DateTimeField('Data de publicação')

    def __str__(self):
        return ("{0} - {1}").format(self.id, self.texto)
    def foi_publicada_recentemente(self):
        return self.data_pub >= timezone.now() - datetime.timedelta(days=1)

class alternativa(models.Model):
    texto = models.CharField(max_length = 50)
    quant_votos = models.IntegerField(
        'Quantidade de votos', default = 0
    )
    pergunta = models.ForeignKey(Pergunta, on_delete = models.CASCADE)
    def __str__(self):
        return ("{0} - {1}").format(self.pergunta.texto, self.texto)

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from .models import Pergunta, alternativa


# Create your views here.
def index(request):
     lista_enquetes = Pergunta.objects.order_by('-data_pub')[:5]
     contexto = {'lista_enquetes': lista_enquetes}

     return render(request, 'index.html', contexto)


def detalhes(request, id_pergunta):


   # recupera as informações a serem apresentadas
    pergunta = get_object_or_404(Pergunta, pk = id_pergunta)
    # cria o mapa de contexto a ser acessado pelo template
    contexto = { 'pergunta': pergunta }
    # solicita a renderização do template
    return render(request, 'detalhes.html', contexto)



def votacao(request, id_pergunta):
    pergunta = get_object_or_404(Pergunta, pk = id_pergunta)
    try:
        id_opcao = request.POST['alternativa']
        selecionada = pergunta.alternativa_set.get(pk = id_opcao)
    except (KeyError, alternativa.DoesNotExist):
        contexto = {
            'pergunta': pergunta,
            'msg_erro': 'Selecione uma opção válida!'
        }
        return render(request, 'detalhes.html', contexto)
    else:
        selecionada.quant_votos += 1
        selecionada.save()
        return HttpResponseRedirect(
            reverse('enquetes:resultado', args=(pergunta.id,))
        )



    resposta = "<h3>Votação referente à enquete %s</h3>"
    return HttpResponse(resposta % id_pergunta)




def resultado(request, id_pergunta):
    resposta = "<h3>Resultados parciais da enquete %s</h3>"
    return HttpResponse(resposta % id_pergunta)

mysite/enquetes/templates/detalhes.html
<html>
    <head>
        <title>App Enquete </title>
    </head>
    <body>
        <h1>Aplicação de Enquetes</h1>
        <h3>Detalhes da Enquete #{{pergunta.id}}</h3>
        <h3>{{pergunta.texto}}</h3>
        <u>Data de publicação</u>: {{ pergunta.data_pub }}<br/>
        {% if msg_erro%}
            <hr/>
            <b>{{ msg_erro}}</b>
        {% endif%}
        <br>
        <u> Selecione a alternativa desejada:</u><br/>


        <form action="{% url 'enquetes:votacao' pergunta.id %}" method="post">
        {% csrf_token %}
        <ul>

            {% for alt in pergunta.alternativa_set.all %}
            <input type="radio" name="alternativa" value="{{ alt.id}}" id="alt{{forloop.counter}}"/>

            <label for="alt{{forloop.counter}}">
                {{ alt.texto}}
                <br>
            </label>

            {% endfor%}
        </ul>

        <input type = "submit" value = "Envie seu voto"/>
        </form>

    </body>
</html>

mysite/enquetes/templates/index.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h1>Aplicação de Enquetes</h1>

        <h3>Lista de enquetes cadastradas:</h3>

        {% if lista_enquetes %}
            <ul>
                {% for pergunta in lista_enquetes %}
                    <li> <a href="{% url 'enquetes:detalhes' pergunta.id %}">{{pergunta.texto}}</a></li>
                {% endfor %}
            </ul>
        {% else %}
            <h3>Nenhuma enquete cadastrada até o momento!</h3>
        {% endif %}
    </body>
</html>